/**
 * @file vertex.cpp
 * @author Léo Perrin
 * @date 2011/11/23
 */

#include <vector>
#include <string>
#include <sstream>


#include "vertex.h"


int str2num(std::string s)
{
        int number;
        std::stringstream ss(s);
        ss>>number;
        return number;
}


Vertex::Vertex(unsigned int ind)
{
	index = ind;
}


Vertex::Vertex(unsigned int ind, std::vector<unsigned int> close)
{
	index = ind;
	neighbours = close;
}


Vertex Vertex::line2vertex(std::string line)
{
	// Taking the index:
	unsigned int pos = line.find(":");
	int index = str2num(line.substr(0,pos)) - 1; //start at 0, not 1
	line=line.substr(pos+1,std::string::npos);
	// going through the line and picking the numbers
	std::vector<unsigned int> close;
	std::string num = "";
	for(unsigned int i=0; i<line.size(); i++)
	{
		if (line[i] == ' ')
		{
			unsigned int neighbour = (unsigned int)str2num(num) - 1;
			close.push_back(neighbour);
			num = "";
		}
		else
			num += line[i];
	}
	// adding the last number if is IS a number (and not some residual
	// space
	if (line[line.size()-1] != ' ')
	{
		unsigned int neighbour = (unsigned int)str2num(num) - 1;
		close.push_back(neighbour);
	}
	Vertex newVertex(index,close);
	return newVertex;
}


void Vertex::addNeighbour(unsigned int index)
{
	neighbours.push_back(index);
}


unsigned int Vertex::getIndex()
{
	return index;
}


std::vector<unsigned int> Vertex::getNeighbours()
{
	return neighbours;
}


unsigned int Vertex::order()
{
	return neighbours.size();
}
