#!/bin/bash

# Solves the slitherlink instance given as the first argument using
# the slitherlink2formula and assignment2slitherlink programs and
# minisat.

# copying the slitherlink to be able to read when outputing the
# solution
cp $1 current_slitherlink.txt

# writing some fancy stuff to the results.txt file
echo "" >> results.txt
echo "--------" >> results.txt
echo "" >> results.txt
echo $1 >> results.txt
grep "x" $1 >> results.txt

# computing the CNF and appending the time it took to the results.txt
# file
bash -c "time ./slitherlink2formula "$1" "$1".dim" 2>> results.txt
echo "clauses="$(wc -l $1.dim | cut -d " " -f 1) >> results.txt
echo "" >> results.txt

# we consider that instances are always satisfiable and don't care
# about what minisat has to say so we redirect its output to /dev/null
# and append the time to the results file
bash -c "time minisat $1.dim $1.res > /dev/null" 2>> results.txt
cat $1.res | ./assignment2slitherlink

# cleaning the mess
rm $1.res $1.dim